interface axis_intf #(
    parameter DATA_WIDTH = 8,
    parameter KEEP_WIDTH = (DATA_WIDTH/8),
    parameter ID_WIDTH = 8,
    parameter DEST_WIDTH = 8,
    parameter USER_WIDTH = 1
);

    logic [DATA_WIDTH-1:0]         tdata;
    logic [KEEP_WIDTH-1:0]         tkeep;
    logic                          tvalid;
    logic                          tready;
    logic                          tlast;
    logic [ID_WIDTH-1:0]           tid;
    logic [DEST_WIDTH-1:0]         tdest;
    logic [USER_WIDTH-1:0]         tuser;

    modport MASTER (

        output tdata,
        output tkeep,
        output tvalid,
        input  tready,
        output tlast,
        output tid,
        output tdest,
        output tuser
    );

    modport SLAVE (
        input  tdata,
        input  tkeep,
        input  tvalid,
        output tready,
        input  tlast,
        input  tid,
        input  tdest,
        input  tuser
    );

endinterface