interface cpuif_intf #(
    parameter CPUIF_WIDTH=32,
    parameter ADDR_WIDTH=32
);

    logic                   req;
    logic                   req_is_wr;
    logic [ADDR_WIDTH-1:0]  addr;
    logic [CPUIF_WIDTH-1:0] wr_data;
    logic [CPUIF_WIDTH-1:0] wr_biten;
    logic                   req_stall_wr;
    logic                   req_stall_rd;
    logic                   rd_ack;
    logic                   rd_err;
    logic [CPUIF_WIDTH-1:0] rd_data;
    logic                   wr_ack;
    logic                   wr_err;


    modport SLAVE (
        input   req,
        input   req_is_wr,
        input   addr,
        input   wr_data,
        input   wr_biten,
        output  req_stall_wr,
        output  req_stall_rd,
        output  rd_ack,
        output  rd_err,
        output  rd_data,
        output  wr_ack,
        output  wr_err
    );

    modport MASTER (
        output req,
        output req_is_wr,
        output addr,
        output wr_data,
        output wr_biten,
        input  req_stall_wr,
        input  req_stall_rd,
        input  rd_ack,
        input  rd_err,
        input  rd_data,
        input  wr_ack,
        input  wr_err
    );

endinterface