interface eth_intf #(
    parameter DATA_WIDTH = 8,
    parameter KEEP_WIDTH = (DATA_WIDTH/8),
    parameter ID_WIDTH = 8,
    parameter DEST_WIDTH = 8,
    parameter USER_WIDTH = 1
);

    logic                          eth_hdr_valid;
    logic                          eth_hdr_ready;
    logic [47:0]                   eth_dest_mac;
    logic [47:0]                   eth_src_mac;
    logic [15:0]                   eth_type;
    logic [DATA_WIDTH-1:0]         eth_payload_axis_tdata;
    logic [KEEP_WIDTH-1:0]         eth_payload_axis_tkeep;
    logic                          eth_payload_axis_tvalid;
    logic                          eth_payload_axis_tready;
    logic                          eth_payload_axis_tlast;
    logic [ID_WIDTH-1:0]           eth_payload_axis_tid;
    logic [DEST_WIDTH-1:0]         eth_payload_axis_tdest;
    logic [USER_WIDTH-1:0]         eth_payload_axis_tuser;

    modport MASTER (
        output eth_hdr_valid,
        input  eth_hdr_ready,
        output eth_dest_mac,
        output eth_src_mac,
        output eth_type,
        output eth_payload_axis_tdata,
        output eth_payload_axis_tkeep,
        output eth_payload_axis_tvalid,
        input  eth_payload_axis_tready,
        output eth_payload_axis_tlast,
        output eth_payload_axis_tid,
        output eth_payload_axis_tdest,
        output eth_payload_axis_tuser
    );

    modport SLAVE (
        input  eth_hdr_valid,
        output eth_hdr_ready,
        input  eth_dest_mac,
        input  eth_src_mac,
        input  eth_type,
        input  eth_payload_axis_tdata,
        input  eth_payload_axis_tkeep,
        input  eth_payload_axis_tvalid,
        output eth_payload_axis_tready,
        input  eth_payload_axis_tlast,
        input  eth_payload_axis_tid,
        input  eth_payload_axis_tdest,
        input  eth_payload_axis_tuser
    );

endinterface
